
// ************************************************************************* //
//                                                                           //
// CYMPLAY                                                                   //
// =======                                                                   //
//                                                                           //
// History :-                                                                //
//                                                                           //
// Win32 v0.21(19/Dec/98) - Updated version information, cleaned up code a   //
// **********************   little, now reflect's NEON's code a bit better. //
//                                                                           //
// Win32 v0.2 (17/Dec/98) - Now works in Release Mode!!! Hoorayy!!           //
// **********************                                                    //
//                                                                           //
// Win32 v0.1 (16/Dec/98) - Finaly got it to compile!! Still gives loads of  //
// **********************   type mismatches however!  And it only works in   //
//							debug mode :(  But it WORKS!!! ;)				 //
//																			 //
//							WARNING! (This is important!)					 //
//							========										 //
//																			 //
//							This code probably has tons of memory leaks!!	 //
//							(Entirely my fault...  I am still learning!)	 //
//							SO make sure that you save every thing down		 //
//							before you try running it!!!					 //
//																			 //
//							Note : This is just a straight copy of the DOS   //
//						           code, all I have done is changed bits     //
//								   here and there to get it to compile       //
//								   with M$ C++ 4.  If anybody cleans up the  //
//								   code, I would appreciate a copy.. :)		 //
//																			 //
// v0.1 (13/Dec/98)       - Plays the CYM file back fine. Is extremely slow  //
// ****************         however! It needs at least a P233MMX to play the //
//                          sound properly (no scratching, full-speed).      //
//                          Audio streams working OK, I think. (Seal rulez!) //
//                          Emulation working great, no probs! (MAME yeah!)  //
//                                                                           //
// ************************************************************************* //

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <FCNTL.H>
#include <windows.h>
#include <SYS\STAT.H>
#include <malloc.h>

#include "sound.c"      // OSD_audio_streams (from M.A.M.E 0.34b8)
#include "ym2151.c"     // YM2151 emulator (from M.A.M.E 0.34b8)

int data_sample_rate = 44100;

int throttle = 1;       // throttle , auto-frame-skip?

                        // 0 = left  \_ YM2151 sound output
int channel = 0;        // 1 = right /  (no, its not stereo, i just want more volume)

FILE *cym_file = NULL;
int cym_file_handle = -1;
unsigned char *cym_data;
unsigned char *cym_data_glb;
unsigned char *ymBuff;

void main(int argc, char *argv[])
{   
    long cym_file_length = 0;
    long cym_data_pos = 0;
    int cym_YM2151_register = 0;
    int cym_YM2151_value = 0;
    unsigned char *ym2151_buffer = NULL;
    int buffer_size = 650;    // sample_rate/fps suposedly    //Changed from 800 by Chipmunk.  Sounds better :)
    int loop = 0;
	int hitkey = 0;
	
    if (argc != 2)
    {
        printf("\n CYMPLAY v0.21! (c)NEON\n");
        printf("\n Use : CYMPLAY <.CYM file>\n");
        exit(0);
    }

	// little messages
    printf("\n # CYMPLAY v0.21! (c)NEON\n");    
    printf(" # Win32 Port by Chipmunk\n");
    printf(" #   -Have a look at the sources somebody!!  It works, but it ain't pretty :(\n");
    
    // initialize Seal and the sound hardware
    msdos_init_seal();
    msdos_init_sound();

    printf(" # Seal Audio Initialized!\n");    

    ///////////////////////////////////////////////////////////////
    // Load the CYM file into memory
    ///////////////////////////////////////////////////////////////
    
	cym_file_handle = _open(argv[1], _O_RDONLY | _O_BINARY,_S_IREAD);
    if (cym_file_handle == -1)
    {
        printf("\nERROR:\tFILE DOES NOT EXIST\n");
        exit(0);
    }
    cym_file_length = filelength(cym_file_handle);
    cym_data_glb = GlobalAlloc(GPTR, (long)cym_file_length);   
	cym_data = GlobalLock(cym_data_glb);
    _read(cym_file_handle, cym_data, cym_file_length);
    _close(cym_file_handle);
	printf(" # CYM File Loaded!\n");
    
    ///////////////////////////////////////////////////////////////
    // Initialize the YM2151
    ///////////////////////////////////////////////////////////////
        
	// This buffer was not getting initialised anywhere!  (At lease I couldn't find it, so
	// I decided to do it here...
	if (sizeof(ym2151_buffer)<buffer_size)
	{
		ymBuff = GlobalAlloc(GPTR, (long)buffer_size);
		ym2151_buffer=GlobalLock(ymBuff);
	}
    // YMInit(number of chips, hz rate, sample rate, sample bit, buffer size, ym buffer)
    YMInit(1, (double)3750000, data_sample_rate, 16, buffer_size, ym2151_buffer);
    // reset chip 0, our one and only chip.
    YMResetChip(0);
    printf(" # YM2151 Initialized & Ready!\n");
    
    printf(" # Playing! - Press any key to Quit!\n");
    
    ///////////////////////////////////////////////////////////////
    
    while (cym_data_pos < cym_file_length && (!(hitkey==27)))
    {        
        // 0x00 // VBLANK // UPDATE //
        if (cym_data[cym_data_pos] == 0x00)
        {
                YM2151Update();
                Sleep(2);		//This seems to make the music less scratchy...  -   Don't ask.. :)
                // channel   = 0 = left
                // channel+1 = 1 = right
                                
                // filter to be applied - heaven knows why?! - probably does nothing actually!
                apply_RC_filter_16(channel, (signed short *)ym2151_buffer, buffer_size, data_sample_rate);
                apply_RC_filter_16(channel+1, (signed short *)ym2151_buffer, buffer_size, data_sample_rate);
                // streams my channel (voice) - "buffer_size * 2" data is needed to stop running over end!
                osd_play_streamed_sample_16(channel, (signed short *)ym2151_buffer, buffer_size * 2, data_sample_rate, 255, 0);
                osd_play_streamed_sample_16(channel+1, (signed short *)ym2151_buffer, buffer_size * 2, data_sample_rate, 255, 127);
            
            cym_data_pos++;
        }

        // !0x00 // YM2151 // DATA WRITE //
        if (cym_data[cym_data_pos] != 0x00)
        {             
            cym_YM2151_register = cym_data[cym_data_pos];
            cym_data_pos++;
            cym_YM2151_value = cym_data[cym_data_pos];
            YMWriteReg(0, cym_YM2151_register, cym_YM2151_value);
            cym_data_pos++;
        }    

		hitkey=_kbhit();
		if (!(hitkey==0))
		{
			hitkey=27;
		}
    }

	GlobalUnlock(ym2151_buffer);
	GlobalFree(ymBuff);

	GlobalUnlock(cym_data);
	GlobalFree(cym_data_glb);

    // shutdown eveything and exit
    YMShutdown();
    exit(0);
}
